﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace Sandbox.Editor
{
    /// <summary>
    /// Displays an objects properties for editing
    /// </summary>
    public partial class PropertyEditor : Form
    {
        private object selectedObject;
        /// <summary>
        /// Creates a new Proper Editor instance.
        /// </summary>
        public PropertyEditor()
        {
            //Initialize for components
            InitializeComponent();
        }
        /// <summary>
        /// Creates a new Proper Editor instance.
        /// </summary>
        /// <param name="selectedObject">Object to edit properties of.</param>
        public PropertyEditor(object selectedObject)
        {
            //Initialize for components
            InitializeComponent();
            //Set forms selected object
            // to the object passed through the parameter
            SelectedObject = selectedObject;
        }
        /// <summary>
        /// Gets or sets the object for which the form displays properties.
        /// </summary>
        public object SelectedObject
        {
            get { return selectedObject; }
            set { selectedObject = value; OnSelectedObjectChange(value); }
        }
        /// <summary>
        /// Updates the property grids selected object when our
        /// forms selected object property is changed.
        /// </summary>
        /// <param name="newObject">New object for which to display properties</param>
        protected void OnSelectedObjectChange(object newObject)
        {
            //Set propertyGrid1's selected object to our new one.
            propertyGrid1.SelectedObject = newObject;
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            //Close form and return OK dialog result
            DialogResult = DialogResult.OK;
        }
    }
}
