﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing.Design;
using System.ComponentModel;
using Sandbox.Controls;
using System.Windows.Forms;

namespace Sandbox.Editor
{
    public class UIIdentSwapper : UITypeEditor
    {
        public override UITypeEditorEditStyle GetEditStyle(
            ITypeDescriptorContext context)
        {
            if (context != null)
                return UITypeEditorEditStyle.Modal;

            return UITypeEditorEditStyle.None;
        }

        public override object EditValue(ITypeDescriptorContext context, 
            IServiceProvider provider, object value)
        {            

            if (context == null || provider == null || context.Instance == null)
                return base.EditValue(provider, value);

            IdentSwapDialog isd = new IdentSwapDialog((string)value);
            if (isd.ShowDialog() == DialogResult.OK)
            {
                value = isd.Ident;
            }

            return isd.Ident;
        }
    }
}
