﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;
using System.Windows.Forms;

namespace Sandbox.Plugin
{
    public class MapDefinition
    {
        private string mapName;
        private string mapFilename;
        private int mapId;

        //private string varientAuthor;
        //private string varientName;
        //private string varientDescription;

        public List<TagDefinition> TagDefinitions;

        public MapDefinition(int mapId)
        {
            this.mapId = mapId;          
        }

        public string MapName
        {
            get { return mapName; }
        }

        public string MapFilename
        {
            get { return mapFilename; }
        }

        public int MapID
        {
            get { return mapId; }
        }        

        public int Read()
        {           
            string pluginPath = Application.StartupPath + "\\Map Definitions\\" + PluginHandler.GetPlugin(mapId);

            if(!File.Exists(pluginPath))
                return 1;

            XmlDocument plugin = new XmlDocument();
            plugin.Load(pluginPath);            
            XmlElement root = plugin.DocumentElement;

            XmlNode temp = root.SelectSingleNode("//Map//name");
            mapName = temp.InnerText;

            temp = root.SelectSingleNode("//Map//filename");
            mapFilename = temp.InnerText;

            temp = root.SelectSingleNode("//Map/id");
            int id = int.Parse(temp.InnerText);

            if (id != mapId)
                return 2;

            temp = root.SelectSingleNode("//Map//objects");
            TagDefinitions = new List<TagDefinition>();

            foreach (XmlNode node in temp)
            {
                TagDefinition t = new TagDefinition();
                t.TagClass = node.Attributes["class"].Value;
                t.Name = node.Attributes["name"].Value;
                t.FileName = node.Attributes["filename"].Value;
                t.Ident = int.Parse(node.Attributes["ident"].Value);
                t.BitmapLocation = node.Attributes["image"].Value;
                TagDefinitions.Add(t);
            }

            return 0;
        }
    }

    public class TagDefinition
    {
        private string tagClass;
        private string name;
        private string filename;
        private string ident;
        private string bitmapPath;

        public string TagClass
        {
            get { return tagClass; }
            set { tagClass = value; }
        }

        public string Name
        {
            get { return name; }
            set { name = value; }
        }

        public string FileName
        {
            get { return filename; }
            set { filename = value; }
        }

        public int Ident
        {
            get { return int.Parse(ident); }
            set { ident = value.ToString(); }
        }

        public string BitmapLocation
        {
            get { return bitmapPath; }
            set { bitmapPath = value; }
        }
    }
}
