﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;

namespace Sandbox.Plugins
{
    public class MapPlugin
    {
        public List<Tag> Tags;
        public List<string> TagClasses;

        public MapPlugin(string path)
        {
            Tags = new List<Tag>();
            TagClasses = new List<string>();

            XmlTextReader xtr = new XmlTextReader(new FileStream(path, FileMode.Open));
            while (xtr.Read())
            {
                switch (xtr.NodeType)
                {
                    case XmlNodeType.Element:
                        if (xtr.Name == "Tag")
                        {
                            Tag t = new Tag();
                            t.Type = xtr.GetAttribute("Class");
                            bool exist = false;
                            foreach (string s in TagClasses)
                                if (s.Equals(t.Type))
                                    exist = true;
                            if (exist == false)
                                TagClasses.Add(t.Type);
                            t.Filename = xtr.GetAttribute("Path");
                            t.Ident = Convert.ToInt32(xtr.GetAttribute("Ident"));
                            Tags.Add(t);
                        } 
                        break;
                }
            }
        }

        public string GetTagNameFromID(int id)
        {
            foreach (Tag t in Tags)
            {
                if (t.Ident == id)
                {
                    return t.Filename;
                }
            }

            return null;
        }

        public string GetTagTypeFromID(int id)
        {
            foreach (Tag t in Tags)
            {
                if (t.Ident == id)
                {
                    return t.Type;
                }
            }

            return null;
        }

        public int GetIDFromTagName(string filename)
        {
            foreach (Tag t in Tags)
            {
                if (t.Filename == filename)
                {
                    return t.Ident;
                }
            }

            return -1;
        }

        public struct Tag
        {
           public string Type;
           public string Filename;
           public int Ident;
        }
    } 
}
